unit Unit2;
{ This unit demonstrates the two ways to use the DebugBox
  form.  It depends on having the DJMDebug unit added to the
  project, so the DebugBox is automatically created.  Use
  "Add file to project" to add DJMDebug.pas to your project
  to use it this way.  Make sure the DebugBox doesn't become
  the main form!

  The first button leads to a call to the SnapShot
  method, which reports on the current state.

  The second button leads to a call to the Exception method,
  which reports on the state from an except clause.

  For both of these, a stack trace is shown at the time of
  the call.
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm2 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

uses DJMDebug;

{$R *.DFM}

procedure TForm2.Button1Click(Sender: TObject);
  procedure Nested(var arg:TForm2); stdcall;
    procedure Nested2;
    begin
      DebugBox.Snapshot('Deeply nested');
    end;
  begin
    Nested2;
  end;
begin
  Nested(form2);
end;

procedure TForm2.Button2Click(Sender: TObject);
var
  x,y : integer;
begin
  try
    x := 0;
    y := 0;
    x := x div y;
    showmessage(IntToStr(x));
  except
    on Exception do
      DebugBox.ShowException;
  end;
end;


end.
